package wifi.logger.it;

import android.Manifest;
import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.pm.PackageManager;
import android.net.wifi.ScanResult;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.View;
import android.widget.Button;

import java.util.ArrayList;
import java.util.List;

;

public class WifiExampleActivity extends Activity implements View.OnClickListener {
    /** Called when the activity is first created. */
	private WifiManager mainWifi;
	private WifiReceiver receiverWifi;
    private Button button;

    ArrayList<String> wifiAP;
    myWifiAdapter adapter;

    private RecyclerView myRecyclerView;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        button=(Button)findViewById(R.id.button);
        button.setOnClickListener(this);
        receiverWifi=new WifiReceiver();
        registerReceiver(receiverWifi,new IntentFilter(WifiManager.SCAN_RESULTS_AVAILABLE_ACTION));

        wifiAP = new ArrayList<String>();
        adapter = new myWifiAdapter(wifiAP);

        myRecyclerView = (RecyclerView)findViewById(R.id.recyclerViewWifi);
        myRecyclerView.setLayoutManager(new LinearLayoutManager(this));

        myRecyclerView.setAdapter(adapter);

        if (ContextCompat.checkSelfPermission(this,
                Manifest.permission.CHANGE_WIFI_STATE)
                != PackageManager.PERMISSION_GRANTED) {

                ActivityCompat.requestPermissions(this,
                        new String[]{Manifest.permission.CHANGE_WIFI_STATE},0);
            }
        if (ContextCompat.checkSelfPermission(this,
                Manifest.permission.ACCESS_WIFI_STATE)
                != PackageManager.PERMISSION_GRANTED) {

            ActivityCompat.requestPermissions(this,
                    new String[]{Manifest.permission.ACCESS_WIFI_STATE},0);
        }

        if (ContextCompat.checkSelfPermission(this,
                Manifest.permission.ACCESS_FINE_LOCATION)
                != PackageManager.PERMISSION_GRANTED) {

            ActivityCompat.requestPermissions(this,
                    new String[]{Manifest.permission.ACCESS_FINE_LOCATION},0);
        }

        if (ContextCompat.checkSelfPermission(this,
                Manifest.permission.ACCESS_COARSE_LOCATION)
                != PackageManager.PERMISSION_GRANTED) {

            ActivityCompat.requestPermissions(this,
                    new String[]{Manifest.permission.ACCESS_COARSE_LOCATION},0);
        }

    }

    @Override
    public void onClick(View view) {
        mainWifi = (WifiManager) getApplicationContext().getSystemService(Context.WIFI_SERVICE);
        mainWifi.setWifiEnabled(true);
        mainWifi.startScan();
        button.setEnabled(false);
    }

    class WifiReceiver extends BroadcastReceiver {
    	private List<ScanResult> wifiList;

		@Override
		public void onReceive(Context arg0, Intent arg1) {
            Log.v("WIFI_SERVICE","onReceive()");

            wifiList = mainWifi.getScanResults();
            wifiAP.clear();
            adapter.notifyDataSetChanged();

            Log.v("WIFI_SERVICE",String.valueOf(wifiList.size()));
            for (int i = 0; i < wifiList.size(); i++) {
                wifiAP.add(wifiList.get(i).SSID + " - " + String.valueOf(wifiList.get(i).level) + " dBm");
                adapter.notifyItemInserted(wifiAP.size() - 1);
                Log.v("WIFI_SERVICE",wifiList.get(i).SSID);
            }

            button.setEnabled(true);
		}
    }
}